/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef JAC_AP_CAMERADRIVINGSERVICE_CAMERADRIVINGSERVICE_PROXY_H
#define JAC_AP_CAMERADRIVINGSERVICE_CAMERADRIVINGSERVICE_PROXY_H

#include "ara/com/internal/proxy/proxy_adapter.h"
#include "ara/com/internal/proxy/event_adapter.h"
#include "ara/com/internal/proxy/field_adapter.h"
#include "ara/com/internal/proxy/method_adapter.h"
#include "ara/com/crc_verification.h"
#include "jac/ap/cameradrivingservice/cameradrivingservice_common.h"
#include <string>

namespace jac {
namespace ap {
namespace cameradrivingservice {
namespace proxy {
namespace events {
    using CamDrv2CamDrvPerceptionOneEvent = ara::com::internal::proxy::event::EventAdapter<::perception::Cam2CamPerceptionStruct>;
    using CamDrv2CamDrvPerceptionTwoEvent = ara::com::internal::proxy::event::EventAdapter<::perception::Cam2CamPerceptionStruct>;
    using CamDrv2CamDrvPerceptionThreeEvent = ara::com::internal::proxy::event::EventAdapter<::perception::Cam2CamPerceptionStruct>;
    using CamDrv2CamDrvPerceptionFourEvent = ara::com::internal::proxy::event::EventAdapter<::perception::Cam2CamPerceptionStruct>;
    static constexpr ara::com::internal::EntityId CameraDrivingServiceCamDrv2CamDrvPerceptionOneEventId = 30182U; //CamDrv2CamDrvPerceptionOneEvent_event_hash
    static constexpr ara::com::internal::EntityId CameraDrivingServiceCamDrv2CamDrvPerceptionTwoEventId = 28892U; //CamDrv2CamDrvPerceptionTwoEvent_event_hash
    static constexpr ara::com::internal::EntityId CameraDrivingServiceCamDrv2CamDrvPerceptionThreeEventId = 5485U; //CamDrv2CamDrvPerceptionThreeEvent_event_hash
    static constexpr ara::com::internal::EntityId CameraDrivingServiceCamDrv2CamDrvPerceptionFourEventId = 50588U; //CamDrv2CamDrvPerceptionFourEvent_event_hash
}

namespace fields {
}

namespace methods {

} // namespace methods

class CameraDrivingServiceProxy {
private:
    std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
public:
    using HandleType = ara::com::HandleType;
    class ConstructionToken {
    public:
        explicit ConstructionToken(const std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> & proxy)
            : proxyAdapter(proxy),
              CamDrv2CamDrvPerceptionOneEvent(proxyAdapter->GetProxy(), events::CameraDrivingServiceCamDrv2CamDrvPerceptionOneEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              CamDrv2CamDrvPerceptionTwoEvent(proxyAdapter->GetProxy(), events::CameraDrivingServiceCamDrv2CamDrvPerceptionTwoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              CamDrv2CamDrvPerceptionThreeEvent(proxyAdapter->GetProxy(), events::CameraDrivingServiceCamDrv2CamDrvPerceptionThreeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
              CamDrv2CamDrvPerceptionFourEvent(proxyAdapter->GetProxy(), events::CameraDrivingServiceCamDrv2CamDrvPerceptionFourEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()){
        }

        ConstructionToken(ConstructionToken&& other) = default;
        ConstructionToken& operator=(ConstructionToken && other) = default;

        ConstructionToken(const ConstructionToken&) = delete;
        ConstructionToken& operator = (const ConstructionToken&) = delete;
        
        virtual ~ConstructionToken() = default;

        /* Do not use such internal interfaces!!! */
        ara::core::Result<void> InitializeAll()
        {
            ara::core::Result<void> initResult;
            return initResult;
        }
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> GetProxyAdapter()
        {
            return proxyAdapter;
        }
        events::CamDrv2CamDrvPerceptionOneEvent GetCamDrv2CamDrvPerceptionOneEvent() noexcept { return std::move(CamDrv2CamDrvPerceptionOneEvent); }
        events::CamDrv2CamDrvPerceptionTwoEvent GetCamDrv2CamDrvPerceptionTwoEvent() noexcept { return std::move(CamDrv2CamDrvPerceptionTwoEvent); }
        events::CamDrv2CamDrvPerceptionThreeEvent GetCamDrv2CamDrvPerceptionThreeEvent() noexcept { return std::move(CamDrv2CamDrvPerceptionThreeEvent); }
        events::CamDrv2CamDrvPerceptionFourEvent GetCamDrv2CamDrvPerceptionFourEvent() noexcept { return std::move(CamDrv2CamDrvPerceptionFourEvent); }
    private:
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
        events::CamDrv2CamDrvPerceptionOneEvent CamDrv2CamDrvPerceptionOneEvent;
        events::CamDrv2CamDrvPerceptionTwoEvent CamDrv2CamDrvPerceptionTwoEvent;
        events::CamDrv2CamDrvPerceptionThreeEvent CamDrv2CamDrvPerceptionThreeEvent;
        events::CamDrv2CamDrvPerceptionFourEvent CamDrv2CamDrvPerceptionFourEvent;
    };

    virtual ~CameraDrivingServiceProxy()
    {
        CamDrv2CamDrvPerceptionOneEvent.UnsetReceiveHandler();
        CamDrv2CamDrvPerceptionOneEvent.Unsubscribe();
        CamDrv2CamDrvPerceptionTwoEvent.UnsetReceiveHandler();
        CamDrv2CamDrvPerceptionTwoEvent.Unsubscribe();
        CamDrv2CamDrvPerceptionThreeEvent.UnsetReceiveHandler();
        CamDrv2CamDrvPerceptionThreeEvent.Unsubscribe();
        CamDrv2CamDrvPerceptionFourEvent.UnsetReceiveHandler();
        CamDrv2CamDrvPerceptionFourEvent.Unsubscribe();

    }

    explicit CameraDrivingServiceProxy(const HandleType &handle)
        : proxyAdapter(std::make_shared<ara::com::internal::proxy::ProxyAdapter>(::jac::ap::cameradrivingservice::CameraDrivingService::ServiceIdentifier, handle)),
          CamDrv2CamDrvPerceptionOneEvent(proxyAdapter->GetProxy(), events::CameraDrivingServiceCamDrv2CamDrvPerceptionOneEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          CamDrv2CamDrvPerceptionTwoEvent(proxyAdapter->GetProxy(), events::CameraDrivingServiceCamDrv2CamDrvPerceptionTwoEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          CamDrv2CamDrvPerceptionThreeEvent(proxyAdapter->GetProxy(), events::CameraDrivingServiceCamDrv2CamDrvPerceptionThreeEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()),
          CamDrv2CamDrvPerceptionFourEvent(proxyAdapter->GetProxy(), events::CameraDrivingServiceCamDrv2CamDrvPerceptionFourEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()){
        }

    void ThrowError(const ara::core::Result<void>& result) const
    {
        if (!(result.HasValue())) {
#ifndef NOT_SUPPORT_EXCEPTIONS
            ara::core::ErrorCode errorcode(result.Error());
            throw ara::com::ComException(std::move(errorcode));
#else
            std::cerr << "Error: Not support exception, create proxy failed!"<< std::endl;
#endif
        }
    }

    CameraDrivingServiceProxy(const CameraDrivingServiceProxy&) = delete;
    CameraDrivingServiceProxy& operator=(const CameraDrivingServiceProxy&) = delete;

    CameraDrivingServiceProxy(CameraDrivingServiceProxy&&) = default;
    CameraDrivingServiceProxy& operator=(CameraDrivingServiceProxy&&) = default;
    CameraDrivingServiceProxy(ConstructionToken&& token) noexcept
        : proxyAdapter(token.GetProxyAdapter()),
          CamDrv2CamDrvPerceptionOneEvent(token.GetCamDrv2CamDrvPerceptionOneEvent()),
          CamDrv2CamDrvPerceptionTwoEvent(token.GetCamDrv2CamDrvPerceptionTwoEvent()),
          CamDrv2CamDrvPerceptionThreeEvent(token.GetCamDrv2CamDrvPerceptionThreeEvent()),
          CamDrv2CamDrvPerceptionFourEvent(token.GetCamDrv2CamDrvPerceptionFourEvent()){
        static_cast<void>(std::move(token));
    }

    static ara::core::Result<ConstructionToken> Preconstruct(
        const ara::com::HandleType &handle)
    {
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> preProxyAdapter =
            std::make_shared<ara::com::internal::proxy::ProxyAdapter>(
               ::jac::ap::cameradrivingservice::CameraDrivingService::ServiceIdentifier, handle);
        ConstructionToken token{std::move(preProxyAdapter)};
        ara::core::Result<void> initResult {token.InitializeAll()};
        if (initResult.HasValue()) {
            return ara::core::Result<ConstructionToken>(std::move(token));
        } else {
            const ara::core::ErrorCode errorcode{initResult.Error()};
            ara::core::Result<CameraDrivingServiceProxy::ConstructionToken> preResult{errorcode};
            return preResult;
        }
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType>& handler,
        const ara::com::InstanceIdentifier instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(handler, ::jac::ap::cameradrivingservice::CameraDrivingService::ServiceIdentifier, instance);
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType> handler,
        const ara::core::InstanceSpecifier specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(handler, ::jac::ap::cameradrivingservice::CameraDrivingService::ServiceIdentifier, specifier);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::com::InstanceIdentifier instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(::jac::ap::cameradrivingservice::CameraDrivingService::ServiceIdentifier, instance);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::core::InstanceSpecifier specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(::jac::ap::cameradrivingservice::CameraDrivingService::ServiceIdentifier, specifier);
    }

    static void StopFindService(const ara::com::FindServiceHandle& handle)
    {
        ara::com::internal::proxy::ProxyAdapter::StopFindService(handle);
    }

    HandleType GetHandle() const
    {
        return proxyAdapter->GetHandle();
    }
    bool SetEventThreadNumber(const std::uint16_t number, const std::uint16_t queueSize)
    {
        return proxyAdapter->SetEventThreadNumber(number, queueSize);
    }
    events::CamDrv2CamDrvPerceptionOneEvent CamDrv2CamDrvPerceptionOneEvent;
    events::CamDrv2CamDrvPerceptionTwoEvent CamDrv2CamDrvPerceptionTwoEvent;
    events::CamDrv2CamDrvPerceptionThreeEvent CamDrv2CamDrvPerceptionThreeEvent;
    events::CamDrv2CamDrvPerceptionFourEvent CamDrv2CamDrvPerceptionFourEvent;
};
} // namespace proxy
} // namespace cameradrivingservice
} // namespace ap
} // namespace jac

#endif // JAC_AP_CAMERADRIVINGSERVICE_CAMERADRIVINGSERVICE_PROXY_H
